<% . /usr/local/lib/cgi/haserl.sh ; check_instances uinetwork.cgi %>
<% . /usr/local/lib/cgi/generic.sh ; print_http_hdr %>
<% . /usr/local/lib/cgi/status.sh %>
<% . /usr/local/lib/cgi/config.sh %>
<html>
<head>
<meta http-equiv="Content-type" content="text/html;charset=UTF-8">
<title>Development Kit - Settings</title>
<link href="/sys/css/settings.css" rel="stylesheet" type="text/css">
<style type="text/css">
    body,td,th {
      margin-left: 20px;
      font-family: Arial, Helvetica, sans-serif;
      font-size: 13px;
      font-weight: bold;
      color: #333333;
    }
    th.val,td.val {
      background-color: #e6e8eb;
      font-weight: normal;
    }
    th.wh,td.wh {
      background-color: #ffffff;
    }
    img.cmd {
      width: 0px;
      height: 0px;
      visibility: hidden;
    }
    iframe.app_iframe {
      display: block;
      border: none;
      height: 100vh;
      width: calc(100% + 17px);
    }
</style>
<script type="text/javascript" src="/sys/js/util.js"></script>
<script language="javascript">

var is_firefox = navigator.userAgent.toLowerCase().indexOf('firefox') > -1;

/* password check */
function validatePassword(){
  	var password = document.getElementById("pwd_set");
	var password_chk = document.getElementById("pwd_chk");
	var ret=false;
  	if(password.value != password_chk.value) {
    	alert("Passwords don't match! Please correct them before submitting your changes!");
  	} else {
    	ret=true;
  	}
  	return ret;
}

/* hide html table row */
function hide_tr(id){
	el=document.getElementById(id);
	if (el) el.style.display='none';
}

/* show html table row
   Latest version of Firefox use "block" to show previously
   hidden table row when style.display='' is used in JS code
   This causes problems with select options drop down menus
   not being selectable with the mouse, so handle it
   it here differently here */
function show_tr(id){
       	el=document.getElementById(id);
	if (el){
		if (is_firefox){
			el.style.display='table-row';
            	}else{
			el.style.display='';
            	}
	}
}

/* local network params show function */

function view_network_settings(show_static){
        if (show_static == "static"){                                                         
	        show_tr('ip_addr');                                             
                show_tr('netmask');                                             
        	show_tr('gateway');                                             
                show_tr('dns1');                                                
                show_tr('dns2');                                                
                hide_tr('dhcp_name');                                           
        }else{                          
		hide_tr('ip_addr');                                             
		hide_tr('netmask');                                             
		hide_tr('gateway');                                             
		hide_tr('dns1');                                                
		hide_tr('dns2');                                                
		show_tr('dhcp_name');                                           
	}
}

function initNetworkPage(){
	view_network_settings(document.getElementById('net_proto').value);
	showMicLinein('<% cfg_print_param application.audio.mic_linein %>');
}


function showMicLinein(currSelection)
{
	if (currSelection == 'mic'){
		show_tr('mic_boost');
		show_tr('mic_gain');
		show_tr('ad_gain');
	}else{
		hide_tr('mic_boost');
		hide_tr('mic_gain');
		show_tr('ad_gain');
	}
}

function checkIntInputValue(elem,minVal,maxVal,defVal)
{
	// get the entered value
	var newValue=elem.value;
	// if not set, use the default
	if ( newValue == "" ) newValue = defVal;
	// the value must be integer number
	var newValNum=parseInt(newValue, 10);
	// ... and in the range of min-max
	if ( newValNum > maxVal ) newValNum = maxVal;
	if ( newValNum < minVal ) newValNum = minVal;
	if ( newValue != newValNum ){
		elem.value = newValNum;
	}
}

function showHideAecTail(aecOpt)
{
	var tailElem=document.getElementById('aec_tail_row');
	if (aecOpt != "disabled"){
		tailElem.style.display = '';
	}else{
		tailElem.style.display = 'none';
	}
}

function checkHostName(elem)
{
        var hostName=elem.value;
        if (!/^[-A-Za-z0-9\.]*$/.test(hostName)){
                alert('This is a non valid hostname! Characters from A to Z, from a to z, from 0 to 9, . and - only are admitted!');
                elem.value=elem.defaultValue;
        }
}

</script>
<style type="text/css">
<!--
body { margin-left:20px }
table {
	width:600px;
	border-spacing:5px;
}
-->
</style>
</head>
<body onload="initNetworkPage();">

<form name="settings" action=config.cgi method=POST>
<input type=hidden name=return_page value=cgi-bin/uinetwork.cgi>

<table>
	<col style="width:120px">
	<col style="width:480px">
	<tr>
		<td colspan="2"><br><b>NETWORK SETTINGS</b></td>
	</tr>
	<tr>
		<td><font size=2><b>Use Avahi discovery</b></font></td>
        <td><font size=2><% form_print_radio network.avahi.enabled Yes No %> </font>
        </td>
	</tr>
	<tr>
		<td><font size=2><b>Use SonicIP</b></font></td>
        <td><font size=2><% form_print_radio network.sonic_ip.enabled Yes No %> </font>
        </td>
	</tr>
	<tr>
		<td><font size=2><b>SonicIP Volume</b></font></td>
        <td><select size="1" width="140px" id="sonicc_vol" name="network.sonic_ip.volume">
            <option value="0%" <% if cfg_string_compare network.sonic_ip.volume 0% ; then echo -n "selected"; fi %>>0 %</option>
            <option value="10%" <% if cfg_string_compare network.sonic_ip.volume 10% ; then echo -n "selected"; fi %>>10 %</option>
            <option value="20%" <% if cfg_string_compare network.sonic_ip.volume 20% ; then echo -n "selected"; fi %>>20 %</option>
            <option value="30%" <% if cfg_string_compare network.sonic_ip.volume 30% ; then echo -n "selected"; fi %>>30 %</option>
            <option value="40%" <% if cfg_string_compare network.sonic_ip.volume 40% ; then echo -n "selected"; fi %>>40 %</option>
            <option value="50%" <% if cfg_string_compare network.sonic_ip.volume 50% ; then echo -n "selected"; fi %>>50 %</option>
            <option value="60%" <% if cfg_string_compare network.sonic_ip.volume 60% ; then echo -n "selected"; fi %>>60 %</option>
            <option value="70%" <% if cfg_string_compare network.sonic_ip.volume 70% ; then echo -n "selected"; fi %>>70 %</option>
            <option value="80%" <% if cfg_string_compare network.sonic_ip.volume 80% ; then echo -n "selected"; fi %>>80 %</option>
            <option value="90%" <% if cfg_string_compare network.sonic_ip.volume 90% ; then echo -n "selected"; fi %>>90 %</option>
            <option value="100%" <% if cfg_string_compare network.sonic_ip.volume 100% ; then echo -n "selected"; fi %>>100 %</option>
         </td>
	</tr>
	<tr>
	        <td><font size=2><b>Protocol</b></font></td>
		<td>
			<select size="1" width="140px" id="net_proto" name="network.eth0.proto" onchange="view_network_settings(this.value)">
				<option value="dhcp" <% if cfg_string_compare network.eth0.proto dhcp ; then echo -n "selected"; fi %>>DHCP</option>
				<option value="static" <% if cfg_string_compare network.eth0.proto static ; then echo -n "selected"; fi %>>Static</option>
			</select>
	        </td>   
	</tr>		
	<tr id="ip_addr" >
		<td><font size=2><b>IP Address</b></font></td>
		<td><font size=2><input name="network.eth0.ipaddr" size="16" maxlength="15" value="<% cfg_print_param network.eth0.ipaddr %>" onChange="IPAddrCheck(this,0)"></font></td>
	</tr>
	<tr id="netmask" >
		<td><font size=2><b>Netmask</b></font></td>
		<td><font size=2><input name="network.eth0.netmask" size="16" maxlength="15" value="<% cfg_print_param network.eth0.netmask %>" onChange="NetmaskCheck(this)"></font>
        </td>
	</tr>
	<tr id="gateway" >
		<td><font size=2><b>Gateway IP Address</b></font></td>
		<td><font size=2><input name="network.eth0.gateway" size="16" maxlength="15" value="<% cfg_print_param network.eth0.gateway %>" onChange="IPAddrCheck(this,1)"></font>
        </td>
	</tr>
	<tr id="dns1" >
		<td><font size=2><b>Primary DNS</b></font></td>
		<td><font size=2><input name="network.eth0.dns1" size="16" maxlength="15" value="<% cfg_print_param network.eth0.dns1 %>" onChange="IPAddrCheck(this,1)"></font>
        </td>
	</tr>
	<tr id="dns2" >
		<td><font size=2><b>Alternative&nbsp;DNS</b></font></td>
		<td><font size=2><input name="network.eth0.dns2" size="16" maxlength="15" value="<% cfg_print_param network.eth0.dns2 %>" onChange="IPAddrCheck(this,1)"></font>
        </td>
	</tr>
	<tr id="dhcp_name">
		<td><font size=2><b>DHCP Host Name</b></font></td>
		<td>
		     <input name="network.eth0.dhcpname" size="20" maxlength="32" value="<% cfg_print_param network.eth0.dhcpname %>" onChange="checkHostName(this)">
        </td>
	</tr>
	<tr>
		<td><font size=2><b>Web Server Port</b></font></td>
		<td>
		     <input name="httpd.webserver.port" size="5" maxlength="5" value="<% cfg_print_param httpd.webserver.port %>" onChange="PortCheck(this,1)">
        </td>
	</tr>
	<tr id="syslog_addr">
		<td><font size=2><b>Syslog Address</b></font></td>
		<td><font size=2><input name="syslogd.remote.ipaddr" size="16" maxlength="15" value="<% cfg_print_param syslogd.remote.ipaddr %>" onChange="IPAddrCheck(this,1)"></font></td>
	</tr>			
</table>
<table> 
	<col style="width:120px">                                                
	<col style="width:480px">                                   
	<tr>
		<td colspan="2"><br><b>TIME SETTINGS</b><br></td>
	</tr>
	<!--
	<tr>
		<td><font size=2><b>RTC</b></font></td>
	        <td>
			<select size="1" name="rtc.rtc.enabled">
				<option value="true" <% if cfg_string_compare rtc.rtc.enabled true ; then echo -n "selected"; fi %>>enabled</option>
				<option value="false" <% if cfg_string_compare rtc.rtc.enabled false ; then echo -n "selected"; fi %>>disabled</option>
			</select>
		</td>
	</tr>
	-->
	<tr id="ntp_servers1">
		<td><font size=2><b>NTP Server 1</b></font></td>
		<td>
			<input name="ntp.source.server1" size="20" value="<% cfg_print_param ntp.source.server1 %>">
		</td>
	</tr>
	<tr id="ntp_servers2">
		<td><font size=2><b>NTP Server 2</b></font></td>
		<td>
			<input name="ntp.source.server2" size="20" value="<% cfg_print_param ntp.source.server2 %>">
		</td>
	</tr>
	<tr id="ntp_servers3">
		<td><font size=2><b>NTP Server 3</b></font></td>
		<td>
			<input name="ntp.source.server3" size="20" value="<% cfg_print_param ntp.source.server3 %>">
		</td>
	</tr>
</table>

<table>
        <col style="width:120px">                                                
        <col style="width:480px"> 
	<tr>
		<td colspan="2"><br><b>SECURITY SETTINGS</b></td>
	<tr>
		<td>Reboot Function
		<td><% form_print_radio security.reset.enabled Enabled Disabled %>
	<tr>
		<td>Reset Factory Defaults
		<td><% form_print_radio security.defaults.enabled Enabled Disabled %>
	<tr>
		<td>Update Function
		<td><% form_print_radio security.update.enabled Enabled Disabled %>
		
<%
if cfg_string_compare httpd.webserver.password_set "" ; then
      echo -n "
    <tr>
		<td><font size=2><b>Web UI Password</b></font></td>
		<td>
			<input name='pwd_set' id='pwd_set' type=password size='16' maxlength='16' placeholder='Password'>
			<input id='pwd_chk' type=password size='16' maxlength='16' placeholder='Confirm Password'>
		</td>
	
	       "
else
      echo -n "
        <tr> 
	        <td><font size=2><b>Change Password</b></font></td>
		<td>
			<input name='pwd_old' type=password size='16' maxlength='16' placeholder='Old Password'>
			<input name='pwd_new' id='pwd_set' type=password size='16' maxlength='16' placeholder='New Password'>
			<input id='pwd_chk' type=password size='16' maxlength='16' placeholder='Confirm Password'>
		 </td>
	       "
fi
%>

     	<tr>
		<td colspan="2"><hr size="1" noshade></td>
	</tr>   
	<tr>
		<td colspan="2">
		<input type=submit value="Submit" formtarget="_self" onClick="return validatePassword();"><input type=reset value="Cancel">
        </td>
    </tr>    
</table>
</form>

<% [ ! -f /usr/local/www/current/app/app_settings.cgi ] && echo '<!--' %>                                                                                                   
<iframe src="/app/app_settings.cgi" class="app_iframe"></iframe>                             
<% [ ! -f /usr/local/www/current/app/app_settings.cgi ] && echo '-->' %>   

</body>
</html>
