<% . /usr/local/lib/cgi/haserl.sh ; check_instances uistatus.cgi %>
<% . /usr/local/lib/cgi/generic.sh ; print_http_hdr %>
<% . /usr/local/lib/cgi/status.sh %>
<% . /usr/local/lib/cgi/config.sh %>

<html>
<head>
<meta charset="UTF-8">
<link href="/sys/css/basic.css" rel="stylesheet" type="text/css">
<style type="text/css">
body { margin-left:20px}
    .storage {
      border: 1px solid #cccccc;
      font-size: 13px;
    }  
    img.cmd {
      width: 0px;
      height: 0px;
      visibility: hidden;
    }
</style>
</head>
<script type="text/javascript">
function getAndDisplayLics() {
    var URL = '/cgi-bin/get_json_licenses.py';
    var xmlHttp = new XMLHttpRequest();
    xmlHttp.onreadystatechange = function() {
        if (this.readyState == 4 ) {
            if (this.status == 200) {
                displayLics(xmlHttp.responseText)   
            } else {
                console.log("Error getting licenses.")
            }
        }
    }
    xmlHttp.open("GET", URL, true);
    xmlHttp.send(null);
}

function displayLics(licsTxt){
    licsJson = JSON.parse(licsTxt);
    var allLicsHtml = ""
    licsJson.forEach(function(lic) {
        html = makeLicHtml(lic)
        allLicsHtml += html
        allLicsHtml += "\n"
    })
    el = document.getElementById('lic_placeholder')
    el.innerHTML = allLicsHtml
}

function makeLicHtml(lic){
    html = `
            <table>
                <col width=140px>
                <col width=350px>
                <tr>
                    <td colspan="2">
                        <b><br>License</b>
                    </td>
                </tr>
                <tr>
                    <td>Name</td><td> ${lic.name} </td>
                </tr>
                <tr>
                    <td>Status</td><td> ${lic.status} </td>
                </tr>
                <tr>
                    <td>ID</td><td> ${lic.identifier} </td>
                </tr>
                <tr>
                    <td>Issue date</td><td> ${lic.issue_date} </td>
                </tr>
                <tr>
                    <td>Features</td><td> ${lic.features} </td>
                </tr>
                <tr>
                    <td>Signature</td><td> ${lic.validFlag}  </td>
                </tr>
            </table>
            `
    return html
}

</script>


<body onload="getAndDisplayLics()">
<table>
<col width=140px>
<col width=350px>

<tr>
    <td colspan=2><b>Device information</b></td>
</tr>

<tr>
    <td>Hardware type</td>
    <td> <% print_device_type %> (ID <% print_hw_type_id %>)</td>
</tr>

<tr>
    <td>IPAM type</td>
    <td> <% print_ipam_type %> (ID <% print_module_type_id %>)</td>
</tr>

<tr>
    <td>MAC address</td>
    <td> <% print_mac_addr %></td>
</tr>

<tr>
    <td>IP address</td>
    <td> <% print_ip_addr %></td>
</tr>

<tr>
    <td>Netmask</td>
    <td> <% print_netmask %></td>
</tr>

<tr>
    <td>Default gateway</td>
    <td> <% print_default_gw %></td>
</tr>

<tr>
    <td>DNS servers</td>
    <td> <% print_dns_servers %></td>
</tr>

<tr>
    <td>Firmware </td> 
    <td>Flexa</td>
</tr>

<tr>
    <td>Firmware version</td> 
    <td><% print_fw_version %></td>
</tr>

<tr>
    <td>Application</td>
    <td><% uci -q get flexa_app.AppParam.app_name %> </td>
</tr>

<tr>
    <td>Application version</td> 
    <td> <% uci -q get flexa_app.AppParam.version %> </td> 
</tr>

<tr>
    <td>Linux kernel version</td>
    <td> <% print_kernel_version %></td>
</tr>

<tr>
    <td>Bootloader version</td>
    <td> <% print_bootloader_version %></td>
</tr>

<tr><td><br></td></tr>

<tr>
    <td colspan=2><b>System status</b></td>
</tr>

<tr>
    <td>System time</td>
    <td> <% date %></td>
</tr>

<tr>
    <td>Uptime</td>
    <td> <% print_uptime %></td>
</tr>

</table>

<div id="lic_placeholder">Lic placeholder</div>

<br>
<table>
<tr><td><b>Mass storage devices</b>
<tr><td>
<% print_mount_table "class=storage border=0 cellspacing=0 cellpadding=4" "No storage devices connected" %>
</table>
<br>
<img class="cmd" id="send_cmd_img" src="">
</body>
</html>
